# encoding=utf-8
#   ____ ___  _   ___   ____  __
#  / ___/ _ \| \ | \ \ / /\ \/ /
# | |  | | | |  \| |\ V /  \  /
# | |__| |_| | |\  | | |   /  \
#  \____\___/|_| \_| |_|  /_/\_\
#
# Console Nyx Client
#
# Conyx Database Library
#
# version 0.2.0
#
# You can do whatever You want with Conyx.
# But I don't take reponsbility nor even
# implied responsibility for the harm,
# damage, loss or anything negative
# You cause using Conyx.
#
# There is no service provided. The program
# is AS-IS and there is ABSOLUTELY no warranty
# provided.
#

import sys, os, traceback
import sys, os, traceback
# reload(sys)
# sys.setdefaultencoding('utf8')
if ('CONYX') in os.environ:
  sys.path.insert(0, (os.environ['CONYX']+'/lib'))
import curses
import locale
import re
#from conyxDBQuery import conyxDBQuery
#from conyxOps import *
#from tuiBuffer import *

nocolors = {
  'r':"",
  0:"",
  1:"",
  2:"",
  3:"",
  4:"",
  5:"",
  6:"",
  7:"",
  8:"",
  9:"",
  10:"",
  11:"",
  12:"",
  13:"",
  14:"",
  15:"",
  16:""
}

colors = {
  'r':"\033[0m",
  0:"\033[0;30m",
  1:"\033[0;34m",
  2:"\033[0;32m",
  3:"\033[0;36m",
  4:"\033[0;31m",
  5:"\033[0;35m",
  6:"\033[0;33m",
  7:"\033[0;37m",
  8:"\033[1;30m",
  9:"\033[1;34m",
  10:"\033[1;32m",
  11:"\033[1;36m",
  12:"\033[1;31m",
  13:"\033[1;35m",
  14:"\033[1;33m",
  15:"\033[1;37m",
  16:"\033[40m"
}

def esc_length(s):
  #length_esc_exp = re.compile(r"""
  #  \x1b     # literal ESC
  #  \[       # literal [
  #  [;\d]*   # zero or more digits or semicolons
  #  [A-Za-z] # a letter
  #  """, re.VERBOSE).search
  esc_exp = "\x1b\[[;\d]*[A-Za-z]"
  esc_len=0
  for i in re.findall(esc_exp,s): esc_len+=(len(i))
  return(esc_len)

def strip_esc(s):
  strip_esc_exp = re.compile(r"""
    \x1b     # literal ESC
    \[       # literal [
    [;\d]*   # zero or more digits or semicolons
    [A-Za-z] # a letter
    """, re.VERBOSE).sub
  return(strip_esc_exp("", s))


def print_pallete():
 for i in colors.keys():
    print(str(colors[i]) + "| conyx | " + str(i).rjust(4,'0'))

def print_more(print_str,printed_lines,current_page):
  c = colors
  printed_chars=0
  ts = os.get_terminal_size()
  cols = ts.columns
  dlines=ts.lines-1
  printed_chars=0
  #print("|||"+print_str+"|||")
  #for i in (0,len(print_str),cols):
  while printed_chars < len(strip_esc(print_str)):
    #print(str(i)+"||"+str(len(print_str))+"||"+str(cols))
    if (printed_chars>len(strip_esc(print_str))):
      print(print_str[printed_chars:])
    else:
      print(print_str[printed_chars:printed_chars+cols])
    #vypoctu tisknuta pismena pro radkovani bez escape sekvenci
    printed_chars+=cols+esc_length(print_str[printed_chars:printed_chars+cols])
    printed_lines+=1
    if (printed_lines/dlines)>current_page:
      #delim_str="[ ENTER ] "+"-"*(cols-10)
      delim_str="-"*(cols-1)
      input(delim_str)
      current_page+=1
  return(printed_lines,current_page)

def sutf8(string):
  try:
    if sys.version_info.major >= 3:
      return(string)
    else:
      return(string.encode('utf8'))
  except Exception as e:
    pass

def br2nl(text):
  brtext=text.replace('<br />','')
  return(brtext)

def strip_empty_lines_from_end(text):
  lines = text.splitlines()
  #while lines and not lines[0].strip():
  #  lines.pop(0)
  while lines and not lines[-1].strip():
    lines.pop()
  return('\n'.join(lines))

def cleanHtml(text):
  cleanr = re.compile('<.*?>')
  cleantext = re.sub(cleanr,'', text)
  cleantext=cleantext.replace('\n',' ')
  cleantext=cleantext.replace('\r',' ')
  return(cleantext)

def tuiScrollContent(filename,lines):
  try:
    screen=curses.initscr()
    rows,columns=screen.getmaxyx()
    curses.noecho()
    curses.cbreak()
    curses.curs_set(0)
    screen.keypad(1)
    screen.clear()
    screen.refresh()
    clean=[]
    for i in lines:
      clean.append(cleanHtml(i))
    buffer=[]
    #print(clean)
    for j in clean:
      if len(j)>columns:
        for i in range(0,len(j),columns):
          buffer.append(j[i:i+columns])
      else:
        buffer.append(j)
    c=""
    shift=len(buffer)-rows+1
    while c!=ord("q"):
      screen.clear()
      screen.refresh()
      try:
        for y in range(0,rows-1,1):
          buff_row=y+shift
          scr_row=y
          if (buff_row<len(buffer) and buff_row>0):
            screen.addstr(scr_row,0,sutf8(buffer[buff_row]))
            #screen.addstr(scr_row,0,str(buff_row) + '/' + str(len(buffer)))
      except:
        print("ERROR: " + "BUFF_ROW: " + str(y) + " SCR_ROW: " + str(scr_row))
      if c == curses.KEY_DOWN or c==ord("j"):
        if shift<len(buffer)-rows+1: 
          shift+=1
      elif c==ord("h"):
        shift=0
      elif c == curses.KEY_UP or c==ord("k"):
        if shift>0: shift-=1 
      elif c == curses.KEY_PPAGE or c==ord("u"):
        if shift-rows>0: 
          shift-=rows 
        else: 
          shift=0
      elif c == curses.KEY_NPAGE or c==ord("n"):
        if shift<rows-len(buffer)+1: 
          shift+=rows 
        else:
          shift=len(buffer)-rows+1
      elif c == ord("o"): # O - cti od prispevku
        curses.endwin()
        screen.refresh()
        c = screen.getch()
        return(-1)
        #res=conyxDBQuery('select min(id_prispevek) prid from prispevek_cache')
        #print(res)
        #zobrazDiskuzi(str(tui_klub_id),stdscr,1,res[1][0][0])
        #stdscr.clear()      

      screen.refresh()
      c = screen.getch()
  finally:
    curses.endwin()

def tuiBuffer(name,buffer):
  locale.setlocale(locale.LC_ALL, '')
  tuiScrollContent(name,buffer)
